#ifndef _KERNEL_REGION_H
#define _KERNEL_REGION_H

#include <System/Mem.h>

// Overlapping regions are not well ordered.

static inline bool operator <(::System::Mem::Region &left,
                              ::System::Mem::Region &right)
{
	return left.start < right.start;
}

static inline bool operator <(::System::Mem::Region &left, uint64_t right)
{
	return left.end < right;
}

static inline bool operator >(::System::Mem::Region &left, uint64_t right)
{
	return left.start > right;
}

namespace Mem {
	static inline ::System::Mem::RegionWithOffset
	add_offset(::System::Mem::Region &region)
	{
		::System::Mem::RegionWithOffset ret;
		ret.start = region.start;
		ret.end = region.end;
		ret.offset = 0;
		return ret;
	}

	static inline ::System::Mem::Region
	remove_offset(::System::Mem::RegionWithOffset &region)
	{
		::System::Mem::Region ret;
		ret.start = region.start;
		ret.end = region.end;
		return ret;
	}
}

#endif
