#ifndef _KERN_LIBC_H
#define _KERN_LIBC_H

#include <kern/types.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>

extern "C" {
	// FIXME: template/alignof versions
	void *memcpy(void *dest, const void *src, size_t len);
	void *memmove(void *dest, const void *src, size_t len);
	int memcmp(const void *b1, const void *b2, size_t len);
	void *memset(void *b, int ch, size_t len);

	void bzero(void *b, size_t len);
	
	void *malloc(size_t size);
	void free(void *ptr);
	void abort();
}

void run_ctors();

// Placement new operators

inline void *operator new(size_t len, void *addr)
{
	return addr;
}

inline void *operator new[](size_t len, void *addr)
{
	return addr;
}

#endif
